#include <curses.h>

#include "mini-mine.h"


void
mine_field_clean()
{
  int x, y;
  marks_true = 0;
  marks_false = 0;
  for (x = 0; x < mine_field_xmax; x++)
    {
      for (y = 0; y < mine_field_ymax; y++)
	{
	  (void) mvaddch(y+1,x*2+1,'.');
	  mine_field_player[x][y] = EMPTY;
	}
    }
}


void
mine_field_show(int x, int y)
{
  switch (mine_field[x][y])
    {
    case EMPTY:
      (void) mvaddch(y+1,x*2+1,' ');
      break;
    case MINE:
      (void) mvaddch(y+1,x*2+1,'*');
      break;
    default:
      (void) mvaddch(y+1,x*2+1,(char)(mine_field[x][y] + 48));
    }
  mine_field_player[x][y] = SET;
}

void
mine_field_cursor(int x, int y, char draw)
{
  (void) mvaddch(y+1,x*2+2, (draw) ? '<' : ' ');
  (void) mvaddch(y+1,x*2, (draw) ? '>' : ' ');
}

void
mine_field_display_mark(int x, int y, char draw)
{
  (void) mvaddch(y+1,x*2+1, (draw) ? '#' : '.');
}
