#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "mini-mine.h"


void
initmf ()
{
  int i;
  int x, y, dx, dy;

  srand ((unsigned int) time ((time_t *) NULL));

  /* thirst erease the field */
  for (x = 0; x < mine_field_xmax; x++)
    {
      for (y = 0; y < mine_field_ymax; y++)
	{
	  mine_field[x][y] = EMPTY;
	}
    }

  /* now place the mines */
  for (i = 0; i < mine_field_mines; i++)
    {
      x = (int) ((double) mine_field_xmax * rand () / (RAND_MAX));
      y = (int) ((double) mine_field_ymax * rand () / (RAND_MAX));
      if (mine_field[x][y] != MINE)
	mine_field[x][y] = MINE;
      else
	{
	  i--;
	  continue;
	}
    }

  /* finaly we must set the hints */
  for (x = 0; x < mine_field_xmax; x++)
    {
      for (y = 0; y < mine_field_ymax; y++)
	{
	  if (mine_field[x][y] == MINE)
	    continue;
	  for (dy = -1; dy <= 1; dy++)
	    {
	      for (dx = -1; dx <= 1; dx++)
		{
		  if ((dx == 0) && (dy == 0))
		    continue;
		  else if ((x + dx >= 0) && (x + dx < mine_field_xmax)
			   && (y + dy >= 0) && (y + dy < mine_field_ymax)
			   && (mine_field[x + dx][y + dy] == MINE))
		    mine_field[x][y]++;
		}
	    }
	}
    }
}


#ifdef DEBUG
void
displaymf ()
{
  int x, y;
  for (x = 0; x < mine_field_xmax; x++)
    {
      for (y = 0; y < mine_field_ymax; y++)
	{
	  mine_field_show(x,y);
	}
    }
}
#endif


char
mine_field_pic(int x, int y)
{
  int dx, dy;
  char game_ends = EMPTY;
  if (!(mine_field_player[x][y]))
    {
      switch (mine_field[x][y])
	{
	case MINE:
	  mine_field_show(x,y);
	  game_ends = LOOSE;
	  break;
	case EMPTY:
	  for (dy = -1; dy <= 1; dy++)
	    {
	      for (dx = -1; dx <= 1; dx++)
		{
		  if ((dx == 0) && (dy == 0))
		    mine_field_show(x,y);
		  else if ((x + dx >= 0) && (x + dx < mine_field_xmax)
			   && (y + dy >= 0) && (y + dy < mine_field_ymax))
		    mine_field_pic(x+dx,y+dy);
		}
	    }
	  break;
	default:
	  mine_field_show(x,y);
	}
    }
  return(game_ends);
}


void
mine_field_mark(int x, int y)
{
  if (mine_field_player[x][y] == EMPTY)
    {
      mine_field_player[x][y] = MINE;
      mine_field_display_mark(x,y,1);
      if (mine_field[x][y] == MINE)
	marks_true++;
      else
	marks_false++;
    }
  else if (mine_field_player[x][y] == MINE)
    {
      mine_field_player[x][y] = EMPTY;
      mine_field_display_mark(x,y,0);
      if (mine_field[x][y] == MINE)
	marks_true--;
      else
	marks_false--;
    } 
}
